<template lang="pug">
  section.related
    .wrapper
      .related__description
        h2.description__title Reshoot the scene. <span class="description__title--outline">Change your message</span>
        p.description__description Stay on-brand by combining the perfect models, expressions, and environments.
        .description__suggestions
          .suggestions__title Related
          .suggestions__list
            img.list__item(v-for="(alternative, index) in models.items[models.active].alternatives.items" :src="alternative" :class="models.items[models.active].alternatives.active === index && 'list__item--active'" @click="handleClick(models.active, index)")
      .related__canvas
        img.canvas__frame(src="../../static/vue-static/related.png")
        .canvas__image
          .image__object
            img.object__item(v-for="(object, index) in objects.items" :src="object" :class="objects.active === index && 'object__item--active'")
          .image__alternative
            img.alternative__item(v-for="(alternative, index) in models.items[models.active].alternatives.items" :src="alternative" :class="models.items[models.active].alternatives.active === index && 'alternative__item--active'")
          .image__model
            img.model__item(v-if="models.items[models.active].alternatives.active === null" v-for="(model, index) in models.items" :src="model.path" :class="models.active === index && 'model__item--active'")
          .image__background
            img.background__item(v-for="(background, index) in backgrounds.items" :src="background" :class="backgrounds.active === index && 'background__item--active'")
</template>

<script>
import { mapState } from 'vuex'

export default {
  computed: {
    ...mapState({
      models: state => state.landing.models,
      backgrounds: state => state.landing.backgrounds,
      objects: state => state.landing.objects
    })
  },
  methods: {
    handleClick: function (modelIndex, altIndex) {
      this.$store.commit('SET_ALTERNATIVE', { modelIndex, altIndex })
    }
  }
}
</script>

<style lang="scss" scoped>
.related {
  width: 100%;
  height: 100%;
  color: #fff;
  margin-top: 24px;

  @media (min-width: 576px) {
    margin-top: 104px;
  }

  &__description {
    display: flex;
    flex: 1;
    flex-direction: column;
    font-weight: 400;

    & .description {
      &__title {
        font-weight: 600;
        font-size: 32px;
        letter-spacing: -1px;
        text-transform: uppercase;
        text-align: center;
        margin-bottom: 18px;

        @media (min-width: 576px) {
          font-size: 40px;
          letter-spacing: -0.03em;
        }

        @media (min-width: 1024px) {
          text-align: left;
        }

        &--outline {
          color: rgba(255, 255, 255, 0);
          -webkit-text-stroke-width: 1px;
          -webkit-text-stroke-color: #fff;
        }
      }

      &__description {
        width: 80%;
        font-size: 15px;
        line-height: 22px;
        opacity: 0.5;
        margin-bottom: 56px;

        @media (max-width: 1024px) {
          width: 100%;
          text-align: center;
        }
      }

      &__suggestions {
        & .suggestions {
          &__title {
            font-size: 15px;
            font-weight: 500;
            line-height: 22px;
            text-align: center;
            margin-bottom: 16px;

            @media (min-width: 1024px) {
              text-align: left;
            }
          }

          &__list {
            display: flex;
            justify-content: center;
            align-items: center;
            width: 100%;
            margin-bottom: 16px;

            @media (min-width: 1024px) {
              justify-content: space-between;
              margin-bottom: 0;
              margin: -8px;
              width: 60%;
            }

            & .list {
              &__item {
                width: 50px;
                height: 58px;
                margin: 8px;
                background: #f5f5f5;
                border-radius: 4px;
                opacity: 0.3;
                transition: 0.2s;
                cursor: pointer;

                @media (min-width: 576px) {
                  margin-right: 0;
                  width: 80px;
                  height: 96px;
                }

                &:hover {
                  transform: scale(1.1);
                  opacity: 0.5;
                }

                &--active {
                  width: 66px;
                  height: 74px;
                  box-shadow: 0px 0px 25px rgba(#000, 0.25);
                  opacity: 1;

                  @media (min-width: 576px) {
                    width: 96px;
                    height: 112px;
                  }

                  &:hover {
                    transform: scale(1);
                    opacity: 1;
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  &__canvas {
    display: flex;
    justify-content: center;
    align-items: center;
    position: relative;
    flex: 1;
    width: 100%;
    height: 108vw;
    overflow: hidden;

    @media (min-width: 576px) {
      width: 52vw;
      height: 64vw;
    }

    @media (min-width: 1024px) {
      width: 580px;
      height: 614px;
    }

    & .canvas {
      &__frame {
        display: none;
        position: absolute;
        width: 457px;
        height: 502px;
        top: 43px;
        right: 6px;
        z-index: 10;

        @media (min-width: 1024px) {
          display: block;
        }
      }

      &__image {
        position: relative;
        width: 100%;
        height: 100%;
        background: rgba(#fff, 0.1);
        border-radius: 6px;
        overflow: hidden;

        @media (min-width: 1024px) {
          width: 75%;
          height: 75%;
        }

        & .image {
          &__object {
            & .object {
              &__item {
                position: absolute;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                opacity: 0;
                visibility: hidden;
                z-index: 3;
                transition: 0.4s;

                &--active {
                  opacity: 1;
                  visibility: visible;
                  z-index: 3;
                  transition: 0.4s;
                }
              }
            }
          }

          &__model {
            & .model {
              &__item {
                position: absolute;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                opacity: 0;
                visibility: hidden;
                z-index: 2;
                transition: 0.2s;

                &--active {
                  opacity: 1;
                  visibility: visible;
                  transition: 0.2s;
                }
              }
            }
          }

          &__alternative {
            & .alternative {
              &__item {
                position: absolute;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                opacity: 0;
                visibility: hidden;
                z-index: 2;
                transition: 0.2s;

                &--active {
                  opacity: 1;
                  visibility: visible;
                  transition: 0.2s;
                }
              }
            }
          }

          &__background {
            & .background {
              &__item {
                position: absolute;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                opacity: 0;
                visibility: hidden;
                z-index: -1;
                transition: 0.6s;

                &--active {
                  opacity: 1;
                  visibility: visible;
                  z-index: 1;
                  transition: 0.6s;
                }
              }
            }
          }
        }
      }
    }
  }
}

.wrapper {
  display: flex;
  align-items: center;
  position: relative;
  margin: 0 auto;
  padding: 32px 0;
  max-width: 1040px;

  @media (max-width: 1023px) {
    flex-direction: column;
    padding: 32px 16px;
  }
}
</style>
